//
// Written by Igor Tolmachev, IT Samples
//        mailto:support@itsamples.com
//
// Copyright (c) 2009.
//
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name and all copyright 
// notices remains intact. If the source code in this file is used in 
// any  commercial application then a statement along the lines of 
// "Portions copyright (c) Igor Tolmachev, 2009" must be included in 
// the startup banner, "About" box or printed documentation. An email 
// letting me know that you are using it would be nice as well. That's 
// not much to ask considering the amount of work that went into this.
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.
//
// Expect bugs!
// 
// Please use and enjoy, and let me know of any bugs/mods/improvements 
// that you have found/implemented and I will fix/incorporate them into 
// this file. 

// MSNRecoveryDlg.cpp : implementation file
//
#include "stdafx.h"
#include "MSNRecovery.h"
#include "MSNRecoveryDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMSNRecoveryDlg dialog
CMSNRecoveryDlg::CMSNRecoveryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMSNRecoveryDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMSNRecoveryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_LOGO, m_stLogo);
}

BEGIN_MESSAGE_MAP(CMSNRecoveryDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
END_MESSAGE_MAP()

#include <wincred.h>
#include <wincrypt.h>

#pragma comment(lib, "Crypt32.lib")

typedef BOOL (WINAPI* CREDENUMERATEA)(LPCTSTR, DWORD, DWORD*, PCREDENTIALA**);
typedef BOOL (WINAPI* CREDREADA)(LPCTSTR, DWORD, DWORD, PCREDENTIALA*);
typedef VOID (WINAPI* CREDFREE)(PVOID);

// CMSNRecoveryDlg message handlers

BOOL CMSNRecoveryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_hAdvapiDll = LoadLibraryA("advapi32.dll");
	if(!m_hAdvapiDll)
		::MessageBox(m_hWnd, "Cannot load advapi32.dll library", "MSN Recovery Tool", MB_OK|MB_ICONASTERISK);
	else
	{
		GetMSN6Passwords();
		GetMSN7Passwords();
		GetWLPasswords();

		GetDlgItem(IDC_EDIT_INFO)->SetWindowText(m_strInfo);
	}

	return TRUE;
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMSNRecoveryDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMSNRecoveryDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMSNRecoveryDlg::OnClose()
{
	if(m_hAdvapiDll)
		FreeLibrary(m_hAdvapiDll);

	CDialog::OnClose();
}

void CMSNRecoveryDlg::GetMSN6Passwords()
{
	CREDENUMERATEA pCredEnumerateA = (CREDENUMERATEA)GetProcAddress(m_hAdvapiDll, "CredEnumerateA");
	CREDFREE pCredFree = (CREDFREE)GetProcAddress(m_hAdvapiDll, "CredFree");

	if(pCredEnumerateA && pCredFree)
	{
		PCREDENTIALA* CredentialCollection = NULL;
		DATA_BLOB blobCrypt;
		DATA_BLOB blobPlainText;
		DATA_BLOB blobEntropy;
		
		ZeroMemory(&blobCrypt, sizeof(blobCrypt));
		ZeroMemory(&blobPlainText, sizeof(blobPlainText));
		ZeroMemory(&blobEntropy, sizeof(blobEntropy));
		
		DWORD dwCount = 0;

		m_strInfo = "Scanning for MSN Messenger 4.x -  passwords...\r\n------------------------------------------------------------\r\n";

		pCredEnumerateA((LPCTSTR)"Passport.Net\\*", 0, &dwCount, &CredentialCollection);
		if(dwCount)
		{
			char szEntropyStringSeed[37] = "82BD0E67-9FEA-4748-8672-D5EFE5B779B0"; //credui.dll
			short int nEntropyData[37];
			short int nTemp = 0;

			for(int i=0; i<37; i++)
			{
				nTemp = (short int)szEntropyStringSeed[i];
				nTemp <<= 2;
				nEntropyData[i] = nTemp;
			}

			char szValue[512];
			for(int i=0; i<(int)dwCount; i++)
			{
				blobEntropy.pbData = (BYTE*)&nEntropyData;
				blobEntropy.cbData = sizeof(nEntropyData);

				blobCrypt.pbData = CredentialCollection[i]->CredentialBlob;
				blobCrypt.cbData = CredentialCollection[i]->CredentialBlobSize;

				CryptUnprotectData(&blobCrypt, NULL, &blobEntropy, NULL, NULL, 1, &blobPlainText);

				memset(szValue, 0, 512);
				sprintf(szValue, "Username: %s\r\n", CredentialCollection[i]->UserName);
				m_strInfo += szValue;
				memset(szValue, 0, 512);
				sprintf(szValue, "Password: %ls\r\n\r\n", blobPlainText.pbData);
				m_strInfo += szValue;
			}
		}
		else
			m_strInfo += "not found\r\n\r\n";

		pCredFree(CredentialCollection);
	}
}

void CMSNRecoveryDlg::GetMSN7Passwords()
{
	PCREDENTIAL* CredentialCollection = NULL;
	WCHAR szEntropy[] = L"%GKP$^%^&LL(%^$^O&TR$^%^GV6;lxzd";

	DATA_BLOB blobCrypt;
	DATA_BLOB blobPlainText;
	DATA_BLOB blobEntropy;
	DATA_BLOB blobDynEntropy;
    ZeroMemory(&blobCrypt, sizeof(blobCrypt));
    ZeroMemory(&blobPlainText, sizeof(blobPlainText));
    ZeroMemory(&blobEntropy, sizeof(blobEntropy));
    ZeroMemory(&blobDynEntropy, sizeof(blobDynEntropy));

	m_strInfo += "Scanning for MSN Messenger 7.x passwords...\r\n------------------------------------------------------------\r\n";

	HKEY hKeyDynSalt = NULL;
	HKEY hKeyCreds = NULL;
	HKEY hKeyUserCred = NULL;
	DWORD dwCount = 0;
	DWORD dwType = 0;
	DWORD dwDataSize = 0;
	DWORD dwSize = 0;
	DWORD dwRet = RegOpenKeyEx(HKEY_CURRENT_USER, _T("SOFTWARE\\MICROSOFT\\IdentityCRL\\Dynamic Salt"), 0, KEY_READ, &hKeyDynSalt);
	if(dwRet == ERROR_SUCCESS)
	{
		dwSize = sizeof(DWORD);
		dwRet = RegQueryValueEx(hKeyDynSalt, "Size", NULL, &dwType,	(LPBYTE)&dwDataSize, &dwSize);
		if(dwRet == ERROR_SUCCESS && dwDataSize)
		{
			BYTE* pDynamicSalt = new BYTE[dwDataSize];
			dwSize = dwDataSize;
			dwRet = RegQueryValueEx(hKeyDynSalt, "Value", NULL,	&dwType, (LPBYTE)pDynamicSalt, &dwSize);
			if(dwRet == ERROR_SUCCESS)
			{
				blobCrypt.pbData = pDynamicSalt;
				blobCrypt.cbData = dwDataSize;

				blobEntropy.pbData = (LPBYTE)&szEntropy;
				blobEntropy.cbData = 0x40;

				if(CryptUnprotectData(&blobCrypt, NULL, &blobEntropy, NULL, NULL, 1, &blobPlainText))
				{
					memcpy(blobCrypt.pbData, blobEntropy.pbData, blobEntropy.cbData);
					memcpy(blobCrypt.pbData + blobEntropy.cbData, blobPlainText.pbData,	blobPlainText.cbData);

					blobEntropy.cbData += blobPlainText.cbData;
					blobEntropy.pbData = blobCrypt.pbData;
					
					LocalFree(blobPlainText.pbData);
					ZeroMemory(&blobPlainText, sizeof(blobPlainText));

					dwRet = RegOpenKeyEx(HKEY_CURRENT_USER, _T("SOFTWARE\\MICROSOFT\\IdentityCRL\\Creds"), 0, KEY_READ, &hKeyCreds);
					if(dwRet == ERROR_SUCCESS)
					{
						char szValue[512];
						char szMsgrUserName[MAX_PATH];

						while(1)
						{
							dwRet = RegEnumKey(hKeyCreds, dwCount, (LPTSTR)&szMsgrUserName, MAX_PATH);
							if(dwRet != ERROR_SUCCESS)
								break;

							dwRet = RegOpenKeyEx(hKeyCreds,	szMsgrUserName,	0, KEY_READ, &hKeyUserCred);
							if(dwRet == ERROR_SUCCESS)
							{
								dwSize = MAX_PATH;

								BYTE* pEncPassword = new BYTE[MAX_PATH];
								dwRet = RegQueryValueEx(hKeyUserCred, _T("ps:password"), NULL, &dwType, (LPBYTE)pEncPassword, &dwSize);
								if(dwRet == ERROR_SUCCESS && dwType == REG_BINARY)
								{
									blobCrypt.pbData = pEncPassword;
									blobCrypt.cbData = dwSize;

									if(CryptUnprotectData(&blobCrypt, NULL, &blobEntropy, NULL,	NULL, 1, &blobPlainText))
									{
										memset(szValue, 0, 512);
										sprintf(szValue, "Username: %s\r\n", szMsgrUserName);
										m_strInfo += szValue;
										memset(szValue, 0, 512);
										sprintf(szValue, "Password: %ls\r\n\r\n", blobPlainText.pbData);
										m_strInfo += szValue;

										LocalFree(blobPlainText.pbData);
									}
								}

								delete [] pEncPassword;

								RegCloseKey(hKeyUserCred);
								hKeyUserCred = NULL;
							}
							else
								break;

							dwCount++;
						}

						if(hKeyCreds)
							RegCloseKey(hKeyCreds);
					}
					else
						m_strInfo += "not found (cannot open credential key)\r\n\r\n";
				}
			}
			else
				m_strInfo += "not found (cannot fetch dynamic salt data)\r\n\r\n";
			
			delete [] pDynamicSalt;
		}
		else
			m_strInfo += "not found (cannot fetch dynamic salt data)\r\n\r\n";

		if(hKeyDynSalt)
			RegCloseKey(hKeyDynSalt);
	}
	else
		m_strInfo += "not found (cannot open dynamic salt registry key)\r\n\r\n";
}

void CMSNRecoveryDlg::GetWLPasswords()
{
	CREDENUMERATEA pCredEnumerateA = (CREDENUMERATEA)GetProcAddress(m_hAdvapiDll, "CredEnumerateA");
	CREDFREE pCredFree = (CREDFREE)GetProcAddress(m_hAdvapiDll, "CredFree");

	if(pCredEnumerateA && pCredFree)
	{
		PCREDENTIALA* CredentialCollection = NULL;
	
		DWORD dwCount = 0;

		m_strInfo += "Scanning for Windows Live passwords...\r\n------------------------------------------------------------\r\n";

		pCredEnumerateA((LPCTSTR)"WindowsLive:name=*", 0, &dwCount, &CredentialCollection);
		if(dwCount)
		{
			char szValue[512];
			for(int i=0; i<(int)dwCount; i++)
			{
				memset(szValue, 0, 512);
				sprintf(szValue, "Username: %s\r\n", CredentialCollection[i]->UserName);
				m_strInfo += szValue;
				memset(szValue, 0, 512);
				sprintf(szValue, "Password: %ws\r\n\r\n", CredentialCollection[i]->CredentialBlob);
				m_strInfo += szValue;
			}
		}
		else
			m_strInfo += "not found\r\n\r\n";
	
		pCredFree(CredentialCollection);
	}
}
